import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { SidebarContainer } from './sidebar-container.component';
import * as i0 from "@angular/core";
export declare class Sidebar implements AfterContentInit, OnInit, OnChanges, OnDestroy {
    private _container;
    private _ref;
    opened: boolean;
    openedChange: EventEmitter<boolean>;
    mode: 'over' | 'push' | 'slide';
    dock: boolean;
    dockedSize: string;
    position: 'start' | 'end' | 'left' | 'right' | 'top' | 'bottom';
    animate: boolean;
    autoCollapseHeight: number;
    autoCollapseWidth: number;
    autoCollapseOnInit: boolean;
    sidebarClass: string;
    ariaLabel: string;
    trapFocus: boolean;
    autoFocus: boolean;
    showBackdrop: boolean;
    closeOnClickBackdrop: boolean;
    closeOnClickOutside: boolean;
    keyClose: boolean;
    keyCode: number;
    onContentInit: EventEmitter<null>;
    onOpenStart: EventEmitter<null>;
    onOpened: EventEmitter<null>;
    onCloseStart: EventEmitter<null>;
    onClosed: EventEmitter<null>;
    onTransitionEnd: EventEmitter<null>;
    onModeChange: EventEmitter<string>;
    onPositionChange: EventEmitter<string>;
    _onRerender: EventEmitter<null>;
    _elSidebar: ElementRef;
    private _focusableElementsString;
    private _focusableElements;
    private _focusedBeforeOpen;
    private _tabIndexAttr;
    private _tabIndexIndicatorAttr;
    private _wasCollapsed;
    private _shouldAnimate;
    private _clickEvent;
    private _onClickOutsideAttached;
    private _onKeyDownAttached;
    private _onResizeAttached;
    private _isBrowser;
    constructor(_container: SidebarContainer, _ref: ChangeDetectorRef, platformId: Object);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    open(): void;
    close(): void;
    triggerRerender(): void;
    _getStyle(): CSSStyleDeclaration;
    _onTransitionEnd(e: TransitionEvent): void;
    private get _shouldTrapFocus();
    private _focusFirstItem;
    private _onFocusTrap;
    private _setFocused;
    private _initCloseListeners;
    private _initCloseClickListener;
    private _initCloseKeyDownListener;
    private _destroyCloseListeners;
    private _destroyCloseClickListener;
    private _destroyCloseKeyDownListener;
    private _onClickOutside;
    private _onKeyDown;
    private _initCollapseListeners;
    private _destroyCollapseListeners;
    private _collapse;
    get _height(): number;
    get _width(): number;
    get _dockedSize(): number;
    get _isModeOver(): boolean;
    get _isModePush(): boolean;
    get _isModeSlide(): boolean;
    get _isDocked(): boolean;
    get _isLeftOrTop(): boolean;
    get _isLeftOrRight(): boolean;
    get _isInert(): boolean;
    private _normalizePosition;
    static ɵfac: i0.ɵɵFactoryDeclaration<Sidebar, [{ optional: true; }, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Sidebar, "ng-sidebar", never, { "opened": "opened"; "mode": "mode"; "dock": "dock"; "dockedSize": "dockedSize"; "position": "position"; "animate": "animate"; "autoCollapseHeight": "autoCollapseHeight"; "autoCollapseWidth": "autoCollapseWidth"; "autoCollapseOnInit": "autoCollapseOnInit"; "sidebarClass": "sidebarClass"; "ariaLabel": "ariaLabel"; "trapFocus": "trapFocus"; "autoFocus": "autoFocus"; "showBackdrop": "showBackdrop"; "closeOnClickBackdrop": "closeOnClickBackdrop"; "closeOnClickOutside": "closeOnClickOutside"; "keyClose": "keyClose"; "keyCode": "keyCode"; }, { "openedChange": "openedChange"; "onContentInit": "onContentInit"; "onOpenStart": "onOpenStart"; "onOpened": "onOpened"; "onCloseStart": "onCloseStart"; "onClosed": "onClosed"; "onTransitionEnd": "onTransitionEnd"; "onModeChange": "onModeChange"; "onPositionChange": "onPositionChange"; "_onRerender": "_onRerender"; }, never, ["*"], false, never>;
}
